VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "cTab"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Public Key$, Caption$, ImageKey$, MouseOver As Boolean, MouseOverClose As Boolean, ContObj As VB.PictureBox
Attribute Key.VB_VarHelpID = -1
Private mSelected As Boolean

Public Property Get Selected() As Boolean
  Selected = mSelected
End Property
Public Property Let Selected(ByVal RHS As Boolean)
  If mSelected <> RHS Then mSelected = RHS Else Exit Property
  If Not ContObj Is Nothing Then ContObj.Visible = mSelected
End Property

Public Sub Draw(T As cTabBar, P As PictureBox, ByVal OffsX&)
  If mSelected Then
    P.FillColor = T.SelColor
    P.Line (OffsX + 1, 1)-(OffsX + T.TabWidth + 1, P.ScaleHeight + 1), T.SelLineColor, B
    If T.Count > 1 Then DrawCloseIcon T, P, OffsX
  Else
    P.FillColor = IIf(MouseOver, T.HoverColor, P.BackColor)
    P.Line (OffsX, 2)-(OffsX + T.TabWidth + 1, P.ScaleHeight + 1), T.LineColor, B
  End If
  
  P.ForeColor = T.TextColor
  P.CurrentX = OffsX + IIf(Len(ImageKey), 24, 6): P.CurrentY = IIf(mSelected, 4, 6)
  P.Print Caption
End Sub

Private Sub DrawCloseIcon(T As cTabBar, P As PictureBox, ByVal OffsX&)
  Dim FntBuf As Font: Set FntBuf = P.Font 'buffer the original PicBox-Font
  Set P.Font = New StdFont
      P.Font.Name = "WebDings": P.Font.Size = 15: P.CurrentX = OffsX + T.TabWidth - P.TextWidth("=") + 3
      P.CurrentY = -3: P.ForeColor = IIf(MouseOverClose, RGB(200, 22, 22), RGB(200, 188, 188)): P.Print "="
  
      P.Font.Name = "Marlett":  P.Font.Size = 6:  P.CurrentX = OffsX + T.TabWidth - P.TextWidth("r") - 2
      P.CurrentY = 7:  P.ForeColor = vbWhite: P.Print "r"
  Set P.Font = FntBuf
End Sub
 
